// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AnimFX.pas' rev: 3.00

#ifndef AnimFXHPP
#define AnimFXHPP
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Animfx
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS EBitmapConvert;
class PASCALIMPLEMENTATION EBitmapConvert : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EBitmapConvert(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EBitmapConvert(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EBitmapConvert(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EBitmapConvert(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EBitmapConvert(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EBitmapConvert(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EBitmapConvert(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EBitmapConvert(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EBitmapConvert(void) { }
	
};

enum TAnimationOperation { aoMarquee, aoBlinds, aoCheckerboard, aoCrush, aoCrushReveal, aoIris, aoSlider, 
	aoStrip, aoZoom, aoFade, aoMosaic, aoTwister, aoWave, aoMonoSlider, aoBands, aoMonoReveal, aoRGB, aoSpiral, 
	aoCheckerBlinds, aoRandomBars, aoTwinRandomBars, aoSwarm, aoStripedIris, aoPixelate, aoRoll };

enum TAnimationModifier { amLeft, amRight, amUp, amDown };

typedef int TPositiveInteger;

enum TRGBOrder { coRGB, coRBG, coGRB, coGBR, coBRG, coBGR };

struct TNode;
typedef TNode *PNode;

struct TNode
{
	int Value;
	TNode *Next;
} ;

struct TFXParams;
typedef TFXParams *PFXParams;

class DELPHICLASS TAFXState;
class PASCALIMPLEMENTATION TAFXState : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	virtual void __fastcall Init(PFXParams FXParams);
	virtual void __fastcall Done(PFXParams FXParams);
public:
	/* TObject.Create */ __fastcall TAFXState(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TAFXState(void) { }
	
};

class DELPHICLASS TAFXRandomBarsFXState;
class PASCALIMPLEMENTATION TAFXRandomBarsFXState : public Animfx::TAFXState 
{
	typedef Animfx::TAFXState inherited;
	
protected:
	virtual void __fastcall Init(PFXParams FXParams);
	virtual void __fastcall Done(PFXParams FXParams);
	
private:
	TNode *FromHead;
	TNode *FromTail;
	TNode *ToHead;
	TNode *ToTail;
	int PrevFrameNumber;
	void __fastcall CreateList(int MaxNodes, PNode &Head, PNode &Tail);
	void __fastcall DestroyList(PNode &Head, PNode &Tail);
	
public:
	int MaxNodes;
public:
	/* TObject.Create */ __fastcall TAFXRandomBarsFXState(void) : Animfx::TAFXState() { }
	/* TObject.Destroy */ __fastcall virtual ~TAFXRandomBarsFXState(void) { }
	
};

class DELPHICLASS TAFXTwinRandomBarsFXState;
class PASCALIMPLEMENTATION TAFXTwinRandomBarsFXState : public Animfx::TAFXState 
{
	typedef Animfx::TAFXState inherited;
	
protected:
	virtual void __fastcall Init(PFXParams FXParams);
	virtual void __fastcall Done(PFXParams FXParams);
	
private:
	TNode *FromHead;
	TNode *FromTail;
	TNode *ToHead;
	TNode *ToTail;
	int PrevFrameNumber;
	void __fastcall CreateList(int MaxNodes, PNode &Head, PNode &Tail);
	void __fastcall DestroyList(PNode &Head, PNode &Tail);
	
public:
	int MaxNodes;
public:
	/* TObject.Create */ __fastcall TAFXTwinRandomBarsFXState(void) : Animfx::TAFXState() { }
	/* TObject.Destroy */ __fastcall virtual ~TAFXTwinRandomBarsFXState(void) { }
	
};

struct TFXParams
{
	Graphics::TColor FColor;
	TPositiveInteger FDelta;
	TAnimationModifier FModifier;
	bool FReverse;
	TRGBOrder FRGBOrder;
	int FFrameNumber;
	TAFXState* FState;
	Windows::TRect ClientRect;
} ;

class DELPHICLASS TAnimationFX;
class DELPHICLASS TAnimationFXThread;
class PASCALIMPLEMENTATION TAnimationFXThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	TAnimationFX* FAnimationFX;
	void __fastcall Next(void);
	
protected:
	virtual void __fastcall Execute(void);
	
public:
	__fastcall TAnimationFXThread(TAnimationFX* AnimationFX);
public:
	/* TThread.Create */ __fastcall TAnimationFXThread(bool CreateSuspended) : Classes::TThread(CreateSuspended
		) { }
	/* TThread.Destroy */ __fastcall virtual ~TAnimationFXThread(void) { }
	
};

class PASCALIMPLEMENTATION TAnimationFX : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	bool FActive;
	Classes::TStrings* FAbout;
	Graphics::TBitmap* FBitmap;
	Graphics::TBitmap* FOutBitmap;
	TFXParams FFXParams;
	Cardinal FInterval;
	TAnimationOperation FOperation;
	TPositiveInteger FSteps;
	Extctrls::TTimer* FTimer;
	TAnimationFXThread* FAnimationFXThread;
	bool FUseThread;
	Classes::TNotifyEvent FOnDone;
	void __fastcall SetAbout(Classes::TStrings* Value);
	void __fastcall SetActive(bool Value);
	void __fastcall SetBitmap(Graphics::TBitmap* ABitmap);
	HIDESBASE void __fastcall SetColor(Graphics::TColor Value);
	void __fastcall SetCurrentFrame(int Value);
	void __fastcall SetInterval(Cardinal Value);
	void __fastcall SetModifier(TAnimationModifier Value);
	void __fastcall SetOperation(TAnimationOperation Value);
	void __fastcall SetReverse(bool Value);
	void __fastcall SetUseThread(bool Value);
	void __fastcall SetRGBOrder(TRGBOrder Value);
	void __fastcall BitmapChange(System::TObject* Sender);
	void __fastcall FXTimer(System::TObject* Sender);
	void __fastcall Done(void);
	void __fastcall SetupFX(void);
	
protected:
	virtual void __fastcall GenerateFrame(void);
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TAnimationFX(Classes::TComponent* AOwner);
	__fastcall virtual ~TAnimationFX(void);
	void __fastcall Play(void);
	void __fastcall Stop(void);
	void __fastcall Pause(void);
	void __fastcall Resume(void);
	void __fastcall Clear(void);
	
__published:
	__property Classes::TStrings* About = {read=FAbout, write=SetAbout};
	__property bool Active = {read=FActive, write=SetActive, stored=false, nodefault};
	__property Graphics::TBitmap* Bitmap = {read=FBitmap, write=SetBitmap};
	__property Graphics::TColor Color = {read=FFXParams.FColor, write=SetColor, default=-2147483647};
	__property int CurrentFrame = {read=FFXParams.FFrameNumber, write=SetCurrentFrame, nodefault};
	__property TPositiveInteger Delta = {read=FFXParams.FDelta, write=FFXParams.FDelta, default=10};
	__property Cardinal Interval = {read=FInterval, write=SetInterval, default=100};
	__property TRGBOrder RGBOrder = {read=FFXParams.FRGBOrder, write=SetRGBOrder, default=0};
	__property TAnimationModifier Modifier = {read=FFXParams.FModifier, write=SetModifier, default=0};
	__property TAnimationOperation Operation = {read=FOperation, write=SetOperation, default=0};
	__property bool Reverse = {read=FFXParams.FReverse, write=SetReverse, default=0};
	__property bool UseThread = {read=FUseThread, write=SetUseThread, default=0};
	__property TPositiveInteger Steps = {read=FSteps, write=FSteps, default=1};
	__property Align ;
	__property Enabled ;
	__property Visible ;
	__property Classes::TNotifyEvent OnDone = {read=FOnDone, write=FOnDone};
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
	
private:
	bool FModified;
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);
extern PACKAGE bool __fastcall FXMarquee(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, 
	const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXBlinds(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseBlinds(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXCheckerboard(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXCrush(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseCrush(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXCrushReveal(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseCrushReveal(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXIris(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseIris(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXSlider(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseSlider(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXMonoSlider(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseMonoSlider(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXStrip(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseStrip(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXZoom(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXFade(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXMosaic(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXTwister(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, 
	const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXWave(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXBands(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXMonoReveal(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseMonoReveal(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXRGB(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXSpiral(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXCheckerBlinds(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseCheckerBlinds(Graphics::TBitmap* FBitmap, Graphics::TBitmap* 
	FOutBitmap, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXRandomBars(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXTwinRandomBars(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXSwarm(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseSwarm(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXStripedIris(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXReverseStripedIris(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap
	, const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXPixelate(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, 
	const TFXParams &FFXParams);
extern PACKAGE bool __fastcall FXRoll(Graphics::TBitmap* FBitmap, Graphics::TBitmap* FOutBitmap, const 
	TFXParams &FFXParams);

}	/* namespace Animfx */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Animfx;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// AnimFX
